package DisableRegistration::App;

use strict;

our $error = 'New registration and withdrawal are prohibited.';
# {
#     package MT::App::CMS::Members;
#     # MT::App::CMS::Members のハンドラをオーバーライドする
#     sub _secedes_confirm { return MT->instance->error( MT->component( 'DisableRegistration' )->translate( $error ) ) };
#     sub _secedes { return MT->instance->error( MT->component( 'DisableRegistration' )->translate( $error ) ) };
# }

sub init {
    my $app = MT->instance();
    my $q = $app->param;
    if ( $q ) {
        my $mode = $q->param( '__mode' );
        if ( $mode && $mode =~ m/secedes|signup/ ) {
            $app->delete_param( '__mode' ); # __mode => view(default_mode)になる
            $app->add_methods( dummy => \&dummy ); # __mode=dummy を追加して
            $app->{ mode } = 'dummy'; # __mode=dummyへ処理を回す
        }
    }
    $app;
}

sub dummy {
    # __mode=dummy
    return MT->instance->error( MT->component( 'DisableRegistration' )->translate( $error ) );
}

sub error {
    my ( $cb, $app, $tmpl ) = @_;
    my $fmgr = MT::FileMgr->new( 'Local' ) or die MT::FileMgr->errstr;
    my $template = File::Spec->catdir( MT->component( 'DisableRegistration' )->path, 'tmpl', 'error.tmpl' );
    $$tmpl = $fmgr->get_data( $template );
}

1;